
import flash.external.*;

class JS2Flash extends MovieClip {
	private var availableindicator:MovieClip;
	private var calledbackindicator:MovieClip;
	
	private var alreadyRun:Boolean=false;
	
	public function JS2Flash() {}
	
	public function onLoad():Void {
		trace("callee: load");
		
		availableindicator=attachMovie("scriptavailable","script_available",1);
		availableindicator._x=-100;
		
		calledbackindicator=attachMovie("scriptcalledback","script_calledback",3);
		calledbackindicator._x=100;
		
		trace("callee: finished loading");
	}
	
	public function onEnterFrame():Void {
		var answer:Object;
		
		if(alreadyRun) return;
		alreadyRun=true;
		
		trace("callee: first run");
		trace("callee: external initializing");
		if(!ExternalInterface.available) {
			trace("callee: external unavailable");
			return;
		}
		availableindicator.gotoAndStop(2);
		
		trace("callee: adding callback");
		if(! ExternalInterface.addCallback("script_call",this,scriptCalled) ) {
			trace("callee: failed to add callback");
		}
		trace("callee: finished first run");
	}
	
	public function scriptCalled(arg1,arg2):String {
		trace("callee: callback entered");
		if(arg1=="Hello" && arg2=="World") {
			trace("callee: callback succeeded, expected (Hello,World) got (Hello,World)");
			calledbackindicator.gotoAndStop(2);
		} else {
			trace("callee: external called back incorrectly, expected (Hello,World) got ("+arg1+","+arg2+")");
		}
		trace("callee: callback finished");
		return "Too";
	}
}
